#ifndef __ITEM
#define __ITEM

#include <string>
#include "SparseBitArray.h"

// CItem - A single item class.
//	includes : name and vertical database for the item.
class CItem
{
public:
	CItem(ITEM_NAME s);
	~CItem(void);

	V_BIT_ARRAY *GetTransactionMask() { return transactionBitMask; }
	void AddTransaction(int transactionNum);

	int CompareTo(CItem *o);
	std::string CItem::ToString();

	ITEM_NAME name;
	int index; // Index of the item in the array
private:
	int count;
	V_BIT_ARRAY *transactionBitMask;
	std::string s_name;
};

#endif